/*   98 -kuha- for OSAkkie@HariboteOS   Ver.0.1(2006/10/18)  */
/*   Copyright (C) 2006 Akkiesoft.                           */

#include "api.h"

static int win, bpx = 6, bpy = 26;

void wait(int timer, int time)
{
	api_settimer(timer, time);
	for (;;) {
		if (api_getkey(1) == 128) {
			break;
		}
	}
	return;
}

void putstr(char *s, int x, int y, int l)
{
	api_boxfilwin(win + 1, x * 8 + bpx, y * 16 + bpy, (x + l) * 8 + bpx, (y + 1) * 16 + bpy, 0);
	api_putstrwin(win, x * 8 + bpx, y * 16 + bpy, 7, l, s);
	return;
}

void HariMain()
{
	char *buf;
	int timer, i, x, y;

	x = 60 *  8 + 16;
	y = 19 * 16 + 36;

	api_initmalloc();
	buf = api_malloc(x * y);
	win = api_openwin(buf, x, y, -1, "kuha");
	api_boxfilwin(win, bpx, bpy, x + bpx - 16, y + bpy - 36, 0);
	timer = api_alloctimer();
	api_inittimer(timer, 128);

reboot:
	api_boxfilwin(win, bpx, bpy, x + bpx - 16, 32 + bpy, 0);
	wait(timer, 100);

	api_beep(2001000);
	wait(timer, 5);
	api_beep(1000500);
	wait(timer, 5);
	api_beep(0);
	wait(timer, 25);

	putstr("CPU MODE  High", 0, 0, 14);
	wait(timer, 10);
	putstr("MEMORY 128KB OK", 0, 1, 15);
	wait(timer, 15);
	putstr("256", 7, 1, 3);
	wait(timer, 15);
	putstr("384", 7, 1, 3);
	wait(timer, 15);
	putstr("512", 7, 1, 3);
	wait(timer, 15);
	putstr("640", 7, 1, 3);
	wait(timer, 15);

	putstr( "+  128KB OK  ", 13, 1, 14);
	wait(timer, 75 / 10);

	for (i = 256; i < 5121; i += 128) {
		char s[5];
		int j = 3, ic = i;

		do {
			s[j--] = (ic % 10) + '0';
			if ((ic /= 10) == 0)
				break;
		} while (j >= 0);
		while (j >= 0)
			s[j--] = ' ';

		putstr(s, 15, 1, 4);
		wait(timer, 75 / 10);
	}
	wait(timer, 200);

	putstr("                         ", 0, 0, 25);
	putstr("                         ", 0, 1, 25);

	goto reboot;
}
